C Calculates a rotation matrix given an axis of rotation and a 
C   right-handed angle of rotation
C
C [P1 P2 P3] are the components of a unit vector which defines
C   the axis of rotation
C THETA is the angle of rotation in radians
C R is the 3x3 rotation matrix
C
C 
C Reference
C  Worked Examples in the Geometry of Crystals
C  by H. K. D. H. Bhadeshia
C  Published by the Institute of Materials, London, 1987.
C  Equation 8c on page 20
C
      SUBROUTINE MAP_UTIL_ROT(P1,P2,P3,THETA,R)
      IMPLICIT NONE
      REAL P1,P2,P3,THETA,R(9),A5
C
      A5=1.0
       R(1)=P1*P1*(A5-COS(THETA))+COS(THETA)
       R(2)=P1*P2*(A5-COS(THETA))-P3*SIN(THETA)
       R(3)=P1*P3*(A5-COS(THETA))+P2*SIN(THETA)
       R(4)=P2*P1*(A5-COS(THETA))+P3*SIN(THETA)
       R(5)=P2*P2*(A5-COS(THETA))+COS(THETA)
       R(6)=P2*P3*(A5-COS(THETA))-P1*SIN(THETA)
       R(7)=P3*P1*(A5-COS(THETA))-P2*SIN(THETA)
       R(8)=P3*P2*(A5-COS(THETA))+P1*SIN(THETA)
       R(9)=P3*P3*(A5-COS(THETA))+COS(THETA)
C
          RETURN
          END
